<?php
/**
 * @copyright: Copyright © 2021 Firebear Studio GmbH. All rights reserved.
 */

namespace Firebear\PlatformSap\Observer;

use Magento\Customer\Model\Session;
use Magento\Framework\Event\ObserverInterface;
use Magento\Framework\Event\Observer as EventObserver;

class CustomerAssignObserver implements ObserverInterface
{
    /**
     * @var Session
     */
    private $session;

    /**
     * CustomerAssignObserver constructor.
     * @param Session $session
     */
    public function __construct(
        Session $session
    ) {
        $this->session = $session;
    }

    /**
     * @param EventObserver $observer
     */
    public function execute(EventObserver $observer)
    {
        $order = $observer->getEvent()->getOrder();
        $this->session->setSapDelegatedNewCustomerData(
            [
                'order' => $order->getId()
            ]
        );
    }
}
