<?php
/**
 * @copyright: Copyright © 2020 Firebear Studio. All rights reserved.
 * @author   : Firebear Studio <fbeardev@gmail.com>
 */
namespace Firebear\PlatformSap\UI\Customer\Component\Control;

use Magento\Customer\Block\Adminhtml\Edit\GenericButton;
use Magento\Framework\View\Element\UiComponent\Control\ButtonProviderInterface;

/**
 * Sync with SAP button UI component.
 */
class SyncWithSapButton extends GenericButton implements ButtonProviderInterface
{
    /**
     * @inheritdoc
     */
    public function getButtonData(): array
    {
        $customerId = (int)$this->getCustomerId();
        $message = __('Are you sure you want to sync customer with SAP?');
        $url = $this->getUrl('importsap/customer/sync', ['customer_id' => $customerId]);
        $data = [
            'label' => __('Sync with SAP'),
            'class' => 'sync-with-sap',
            'on_click' => "confirmSetLocation('{$message}', '{$url}')",
            'sort_order' => 100
        ];

        return $data;
    }
}
